#!/usr/bin/perl
# change2.cgi
# Change a post, including colateral data

use warnings ;
use strict ;
use DB_File ;

require "session.pl";

## DECLARATIONS
our $dbdir;
require "../conf.pl"; #get $dbdir value from ../conf.pl
$dbdir = "../".$dbdir; #fix $dbdir

my $cnt=0 ; # wild-card counter
my @list;
my $id ;
my $prev ='';
my $br = "<br/>";

# test $ENV{'QUERY_STRING'}
if( length($ENV{'QUERY_STRING'})!=21 || index($ENV{'QUERY_STRING'},"id")!=0 ) { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error0, with input data: ".index($ENV{'QUERY_STRING'},"borrar")."</p></body></html>"; exit 0;}
my ($name, $value) = split(/=/,$ENV{'QUERY_STRING'} );
if($name ne "id") { print "Content-type: text/html; charset=utf-8\n\n<html><body><p>Error1, with input data: ".index($ENV{'QUERY_STRING'},"borrar")."</p></body></html>"; exit 0;}
$id=$value;

## OPENING DATABASES

sub Compare { my ($key1,$key2)=@_; "\L$key2" cmp "\L$key1"; } # getting first the last post
$DB_BTREE->{'compare'} = \&Compare ; # specify the Perl sub that will do the comparison

my %titles ; # to handle titles DB
tie %titles, "DB_File", $dbdir."habla_titles.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'titles': $!\n" ; # error :(
my %texts ; # to handle texts DB
tie %texts, "DB_File", $dbdir."habla_texts.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file 'texts': $!\n" ; # error :(

$DB_BTREE->{'flags'} = R_DUP ; # permit duplication in next DB's
my ($id_tag, %id_tag); # to handle id -> tag DB
$id_tag = tie %id_tag, "DB_File", $dbdir."habla_id_tag.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file id_tag: $!\n" ; # error :(
my ($tag_id, %tag_id); # to handle tag -> id DB
$tag_id = tie %tag_id, "DB_File", $dbdir."habla_tag_id.db", O_RDWR|O_CREAT, 0666, $DB_BTREE # opendb, if it does not exist create
	or die "Cannot open file tag_id: $!\n" ; # error :(



### CREATING HTML # http server head
print "Content-type: text/html; charset=utf-8\n\n
<html><head><title>Perl and BDB example script</title>
<style type=\"text/css\">
body { color: purple; background-color: #dd3; font-size: 0.8em; }
#text {width: 70%; float: left; position: relative; }
#tags {width: 20em;float: left; position: relative; }
#tags ul { padding: 0; list-style: none; }
</style>
</head><body>";

my($first, $second) = split(/<!---->/, $texts{$id}); # searching whereis "<!---->" which separate intro text from extended text
$first =~ s/$br/\n/g; # converting <br/> into \n
$second =~ s/$br/\n/g; # converting <br/> into \n
@list = $id_tag->get_dup($id) ; # get a list of tags for actual post

print "Go to <a href=\"panel_manage.cgi\">Panel</a><br/><br/>
<form name=\"npost\" action=\"change3.cgi\" method=\"post\">
<input type=\"hidden\" name=\"id\" value=\"$id\" />\n
<div id=\"text\">
Title:<br/><input type=\"text\" name=\"title\" value=\"$titles{$id}\" /><br/><br/>
Text:<br/><textarea id=\"text\" cols=\"60\" rows=\"20\" name=\"text\">$first<!---->$second</textarea><br/>
</div><!-- End of text div -->
<div id=\"tags\">
<b>SELECT TAGS</b>
<ul>
";

# show TAGs 
foreach (sort keys %tag_id) # tag_id has multiple equal key
{
	if($prev ne $_){ # for each key, check if it's the same as later read
		print "<li class=\"tag\">$_ :<input type=\"checkbox\" name=\"tag\" value=\"$_\" "; # print each key and repetitions
		if($tag_id->find_dup($_, $id) == 0) { print "checked=\"checked\"";} # checking post tags
		print " /></li>\n";
	}
	$prev = $_ ; # store key to use in next loop. To check no repeated tag are showed
}

print "<li class=\"tag\"><input type=\"checkbox\" name=\"ctag\" value=\"uno\" />
 One new Tag:<input type=\"text\" name=\"ttag\" />(You can add more in next screen)</li>
</ul>\n<input type=\"submit\"/>
</form>
</div> <!-- end of tags div -->
</body></html>";

### CLOSING DATABASES

untie %titles ; #closing db's
untie %texts ;
undef $id_tag ; untie %id_tag ;
undef $tag_id ; untie %tag_id ;


1; # Correct finish with 1